#!/usr/bin/perl
use POSIX qw(setsid);

chdir '/'                 or die "Can't chdir to /: $!";
umask 0;
open STDIN, '/dev/null'   or die "Can't read /dev/null: $!";
open STDOUT, '>/dev/null' or die "Can't write to /dev/null: $!";
open STDERR, '>/dev/null' or die "Can't write to /dev/null: $!";
defined(my $pid = fork)   or die "Can't fork: $!";
exit if $pid;
setsid                    or die "Can't start a new session: $!";
#this daemon captures teletext pages from Turkish NTV news channel
use DBI;
$db2 = 'imkbdaily';
$dsn2 = "DBI:mysql:$db2";
$dbh2 = DBI->connect($dsn2, 'root', '');
($s1,$s2,$s3,$s4,$s5,$s6,$s7,$s8,$s9) = localtime(time);
if ($s3<13) {
$bound = 12;
}
else {
$bound = 16;
}
$mon = $s5 + 1;
$year = 1900 + $s6;
$tarih = "$year-$mon-$s4";
# the daemon exits on the end of each session of the Istanbul Stock
# Market.
while ($s3<$bound || $s2<6) {
# first part, get teletext pages down and stored into ttext-....txt
system("/alevt-cap -finetune auto 301 302 303 304 305 306 307 308 309 \
                      310 311 312 313 314 315 316 317 318 319 320");
# second part, parse ttext pages into data file baslik2
&teletekst;
# thirdly insert the data into imkbdaily of mysql
open(DS2, "baslik2") or die "himmi2$!\n";
while (<DS2>) {
($table,$son,$islem,$saat) = split;
if ($son != 0 && $islem != 0) {
 $dbh2->do("INSERT INTO $table VALUES('$tarih $saat',
          $son,$islem)");
}
}
close(DS2);
sleep 150;
($s1,$s2,$s3,$s4,$s5,$s6,$s7,$s8,$s9) = localtime(time);
}
$dbh2->disconnect;

sub teletekst {
# most of programming effort is due to false data
# that could be captured
open(DS, "baslik") or die "himmi$!\n";
open(DS2, ">baslik2") or die "himmi2$!\n";
($s1,$s2,$s3,$s4,$s5,$s6,$s7,$s8,$s9) = localtime(time);
$saat = "$s3:$s2:$s1";
for ($page=301;$page<321;$page++) {
# store it in case new one couldn"t be read(saat = hour)
$oldsaat = $saat;
open(DF, "ttext-$page.txt") or die "kud nat open$!\n";
$nothi = readline *DF;
$nothi = readline *DF;
$nothi = readline *DF;
$indic1 = ($nothi !~ /\w/);
$nothi = readline *DF;
$indic2 = ($nothi =~ /HiSSE/ || $nothi =~ /ALIS/ ||
           $nothi =~ /SATIS/ || $nothi =~ /SON/);
$line = readline *DF;
$indic3 = ($line =~ /ADI/ || $line =~ /ADEDi/);
# sometimes a unwanted new line is encountered in the beginning
# of the teletekst pages
$line = readline *DF if($indic1 &&($indic2 || $indic3));
@things = ();
for ($i=0;$i<16;$i++) {
$something2 = readline *DS;
chop $something2;
# the close value is determined
$digi1 = substr $line, 28, 1;
$digi2 = substr $line, 27, 1;
$digi3 = substr $line, 26, 1;
$digi4 = substr $line, 25, 1;
$digi5 = substr $line, 24, 1;
$digi6 = substr $line, 23, 1;
$son=$digi1*10+$digi2*100+$digi3*1000+$digi4*10000+
     $digi5*100000+$digi6*1000000;
# the volume is determined
$digi11 = substr $line, 38, 1;
$digi12 = substr $line, 37, 1;
$digi13 = substr $line, 36, 1;
$digi14 = substr $line, 35, 1;
$digi15 = substr $line, 34, 1;
$digi16 = substr $line, 33, 1;
$digi17 = substr $line, 32, 1;
$islem=$digi11+$digi12*10+$digi13*100+$digi14*1000+$digi15*10000+
       $digi16*100000+$digi17*1000000;
push @things,[$something2,$son,$islem] if $something2;
$line = readline *DF;
}
$saat = substr $line, 31,8;
if ($saat =~ /\d/) {
$saat =~ s/[a-zA-Z]/0/g;
$saat =~ s/\?/0/g;
}
else {
$saat = $oldsaat;
}
# reading the information about total index and volume once
if ($page==319) {
$index = substr $line, 1, 5;
$index =~ s/\D/0/g;
$line = readline *DF;
$line = readline *DF;
$line = readline *DF if ($line !~ /TOPLAM/ && $line !~ /iSLEM/ &&
                         $line !~ /HACMi/);
if ($line =~ /TOPLAM/ || $line =~ /iSLEM/ || $line =~ /HACMi/) {
$indisl = substr $line, 20, 7;
$nokta = substr $indisl, 3, 1, '';
$indisl =~ s/\D/0/g;
}
else {
$indisl = 0;
} 
print DS2 "INDEK $index $indisl $saat\n";
}
close(DF);
for ($i=0;$i<16;$i++) {
print DS2 "$things[$i]->[0] $things[$i]->[1] ";
print DS2 "$things[$i]->[2] $saat\n";
} 
}
close(DS);
close(DS2);
}